<?php
/*
Version: 1.0.2
Plugin Name: Evil_Blog
Plugin URI: http://piwigo.org/ext/extension_view.php?eid=611
Author: EvilKant
Description: Small blog at main page.
*/

// Chech whether we are indeed included by Piwigo.
if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
 
global $prefixeTable;
// Определяем директорию плагина
define('Evil_Blog_PATH', PHPWG_PLUGINS_PATH.basename(dirname(__FILE__)).'/');
define('Evil_Blog_Admin', get_root_url() . 'admin.php?page=plugin-' . basename(dirname(__FILE__)));
define('Evil_Blog_Table', $prefixeTable."evil_blog");
//Включаем перевод плагина
load_language('plugin.lang', Evil_Blog_PATH);

//Делаем пункт меню в админке
add_event_handler('get_admin_plugin_menu_links', 'Evil_Blog_admin_menu');

function Evil_Blog_admin_menu($menu) {
 array_push(
   $menu,
   array(
     'NAME'  => 'Evil_Blog',
     'URL'   => get_admin_plugin_menu_link(dirname(__FILE__)).'/admin.php'
   )
 );
 return $menu;
}

//описываем действия во время собырия loc_begin_index, ну тобишь выводим плагин на странице
add_event_handler('loc_begin_index', 'Evil_Blog_main');

function Evil_Blog_main () {
	global $template, $tokens, $conf;
	
	if (empty($tokens[0])) {//если дело происходит на главной странице, то...
		//выковыриваем из базы настройки блога
		$eb_conf = @unserialize($conf['evil_blog']);	
		$post_per_page = $eb_conf['posts_per_page'];
		//узнаем количество записей в блоге
		$row = pwg_db_fetch_assoc(pwg_query("SELECT COUNT(*) FROM `".Evil_Blog_Table."`"));;	

		if ($row["COUNT(*)"] % $post_per_page != 0) {
			$pages = floor($row["COUNT(*)"] / $post_per_page)+1;
			} else {$pages = floor($row["COUNT(*)"] / $post_per_page);}
		if ((empty($_POST['npage'])) or ($_POST['npage']<=1)) {
			$number = 0;
			$npage = 1;
			} else {
				$npage = $_POST['npage'];
				if ($npage<=$pages) {
					$number=($npage-1)*$post_per_page;
					} else {
					$number=($pages-1)*$post_per_page;
					$npage=$pages;
					}
			}
	
		$query = 	"SELECT *
					FROM `".Evil_Blog_Table."`
					WHERE 1
					ORDER BY `date` DESC
					LIMIT ".$number.",".$post_per_page;
		$result = pwg_query($query);
		$qwe = 0;
		while ($row = pwg_db_fetch_assoc($result)) {//более вменяемая обработка результата из базы, нужно для нормальной работы SMARTY
			$row1[$qwe] = $row;
			$qwe++;
			}
		if (!empty($row1)) {
			$template->assign('row', $row1);
			}
		$template->assign('npage', $npage);
		$template->assign('pages', $pages);
		for ($it=1; $it<=$pages; $it++) {
			$pagi[$it] = $it;
			}
		if (!empty($pagi)) { 
			$template->assign('pagi', $pagi);
			}
		$template->assign('blog_name', $eb_conf['blog_name']);
		//определяем адрес шаблона плагина
		$template->set_template_dir(Evil_Blog_PATH);
		$template->set_filename('posts', 'posts.tpl');
		//подключение стиля
		$template->func_combine_css(array(
        'path' => Evil_Blog_PATH.'posts.css',
        )
      );
		
		//объявляем где конкретно на странице должен вывестись наш шаблон плагина. Вся суть в 'PLUGIN_INDEX_CONTENT_BEFORE'.
		$template->concat('PLUGIN_INDEX_CONTENT_BEFORE',  $template->parse('posts', true));
	}
}
?>